diff --git a/game/client/src/main/java/net/minecraft/client/render/font/SF.java b/game/client/src/main/java/net/minecraft/client/render/font/SF.java
index b2751647c..ed72d833d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/font/SF.java
+++ b/game/client/src/main/java/net/minecraft/client/render/font/SF.java
@@ -10,6 +10,7 @@ public final class SF {
     public static final long STRIKETHROUGH = (0b0000_0100L << 32);
     public static final long BOLD = (0b0000_1000L << 32);
     public static final long OBFUSCATED = (0b0001_0000L << 32);
+    public static final long OUTLINE = (0b0010_0000L << 32);
 
     private SF() {}
 
@@ -53,6 +54,14 @@ public final class SF {
         return (config & OBFUSCATED) != 0;
     }
 
+    public static long setOutlined(final long config) {
+        return config | OUTLINE;
+    }
+
+    public static boolean isOutlined(final long config) {
+        return (config & OUTLINE) != 0;
+    }
+
     public static long setColor(final long config, final int color) {
         return (config & ~MASK_COLOR) | color & MASK_COLOR;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index 5d8fd8a28..bda5a26b6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -417,6 +417,9 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
 
         addDispatch(new ItemModelSignPainted(Items.SIGN_PAINTED));
 
+        addDispatch(new ItemModelStandard(Items.FOOD_VENISON_RAW, "minecraft"));
+        addDispatch(new ItemModelStandard(Items.FOOD_VENISON_COOKED, "minecraft"));
+
         for (int i = 0; i < Blocks.blocksList.length; i++) {
             if (Blocks.blocksList[i] == null) continue;
             Item item = Blocks.blocksList[i].asItem();
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
index 2a4977d1e..de7977032 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/AtlasStitcher.java
@@ -51,13 +51,13 @@ public class AtlasStitcher extends Texture {
     protected IconCoordinate getTexture(@NotNull NamespaceID sourceId, @NotNull NamespaceID id){
         if (textureMap.containsKey(id)) return textureMap.get(id);
 
-
-        IconCoordinate iconCoordinate = new IconCoordinate(this, sourceId, id, getSourceImagePath(id));
+        id.makePermanent();
+        IconCoordinate iconCoordinate = new IconCoordinate(this, sourceId.makePermanent(), id, getSourceImagePath(id));
         textureMap.put(id, iconCoordinate);
         return iconCoordinate;
     }
     public String getSourceImagePath(@NotNull NamespaceID id){
-        return String.format("%s/%s/%s/%s.png", rootAssetPath, id.namespace, directoryPath, id.value);
+        return String.format("%s/%s/%s/%s.png", rootAssetPath, id.namespace(), directoryPath, id.value());
     }
 
     public void preinit() {
diff --git a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
index a50d1c083..0afc1a740 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texture/stitcher/TextureRegistry.java
@@ -53,41 +53,31 @@ public class TextureRegistry {
 
     public static @NotNull IconCoordinate getTexture(@NotNull String key){
         try {
-            return getTexture(new NamespaceID(key));
+            return getTexture(NamespaceID.getTemp(key));
         } catch (HardIllegalArgumentException e) {
             throw new RuntimeException(e);
         }
     }
     public static @NotNull IconCoordinate getTexture(@NotNull NamespaceID id){
-        String[] split2 = id.value.split("/");
-        AtlasStitcher atlas = stitcherMap.get(split2[0]);
-        if (atlas == null) throw new IllegalArgumentException("Failed to find atlas '" + split2[0] + "'!");
+        final int slashIndex = id.value().indexOf("/");
+        final AtlasStitcher atlas = stitcherMap.get(id.value().substring(0, slashIndex));
+        if (atlas == null) throw new IllegalArgumentException("Failed to find atlas '" + id.value().substring(0, slashIndex) + "'!");
 
-        StringBuilder target = new StringBuilder(split2[1]);
-        for (int i = 2; i < split2.length; i++) {
-            target.append("/").append(split2[i]);
-        }
-
-        return atlas.getTexture(id, new NamespaceID(id.namespace, target.toString()));
+        return atlas.getTexture(id, NamespaceID.getTemp(id.namespace(), id.value().substring(slashIndex + 1)));
     }
     public static boolean hasTexture(@NotNull String key) {
         try {
-            return hasTexture(new NamespaceID(key));
+            return hasTexture(NamespaceID.getTemp(key));
         } catch (HardIllegalArgumentException e) {
             throw new RuntimeException(e);
         }
     }
     public static boolean hasTexture(@NotNull NamespaceID id){
-        String[] split2 = id.value.split("/");
-        AtlasStitcher atlas = stitcherMap.get(split2[0]);
-        if (atlas == null) throw new IllegalArgumentException("Failed to find atlas '" + split2[0] + "'!");
+        final int slashIndex = id.value().indexOf("/");
+        final AtlasStitcher atlas = stitcherMap.get(id.value().substring(0, slashIndex));
+        if (atlas == null) throw new IllegalArgumentException("Failed to find atlas '" + id.value().substring(0, slashIndex) + "'!");
 
-        StringBuilder target = new StringBuilder(split2[1]);
-        for (int i = 2; i < split2.length; i++) {
-            target.append("/").append(split2[i]);
-        }
-
-        return atlas.textureMap.containsKey(new NamespaceID(id.namespace, target.toString()));
+        return atlas.textureMap.containsKey(NamespaceID.getTemp(id.namespace(), id.value().substring(slashIndex + 1)));
     }
     public static AtlasStitcher register(String id, AtlasStitcher atlas){
         stitcherMap.put(id, atlas);
@@ -113,8 +103,9 @@ public class TextureRegistry {
 //        System.out.println("Printing " + path);
         for (String s : files) {
 //            System.out.println(s);
-            NamespaceID id = new NamespaceID(namespace, s.replace(".png", "").replace("//", "/"));
-            atlas.getTexture(new NamespaceID(id.namespace, stitcherMapReverse.get(atlas) + "/" + id.value), id);
+
+            NamespaceID id = NamespaceID.getTemp(namespace, s.replace(".png", "").replace("//", "/"));
+            atlas.getTexture(NamespaceID.getTemp(id.namespace(), stitcherMapReverse.get(atlas) + "/" + id.value()), id);
         }
     }
 
@@ -193,7 +184,7 @@ public class TextureRegistry {
                         final IconCoordinate coordinate = entry.getValue();
                         writer.append(Integer.toString(coordinate.iconX)).append(",").append(Integer.toString(coordinate.iconY));
                         writer.append("=");
-                        writer.append(entry.getKey().value);
+                        writer.append(entry.getKey().value());
                         writer.append(" <").append(Integer.toString(coordinate.width)).append(",").append(Integer.toString(coordinate.height)).append(">");
                         writer.append("\n");
                     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
index be25210ee..e7100d7f0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
@@ -2,6 +2,7 @@ package net.minecraft.client.render.tileentity;
 
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.TileEntityRenderDispatcher;
+import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.entity.TileEntity;
@@ -44,6 +45,10 @@ public abstract class TileEntityRenderer<T extends TileEntity>
     {
     }
 
+    public void tick() {
+
+    }
+
     protected @NotNull StaticEntityModel getModel(@NotNull final String localId) {
         StaticEntityModel model = this.modelMap.get(localId);
         if (model != null) {
@@ -69,4 +74,8 @@ public abstract class TileEntityRenderer<T extends TileEntity>
     {
         return this.renderDispatcher.getFont();
     }
+
+    public boolean isVisible(@NotNull final T tileEntity, @NotNull final ICamera camera, final float partialTick) {
+        return true;
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
index 183cec6de..cdc633120 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererSign.java
@@ -1,8 +1,11 @@
 package net.minecraft.client.render.tileentity;
 
+import net.minecraft.client.GLAllocation;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.SF;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
@@ -16,17 +19,24 @@ import net.minecraft.core.enums.EnumSignPicture;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.World;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.opengl.GL11;
 import org.lwjgl.opengl.GL12;
 import org.useless.dragonfly.models.entity.StaticEntityModel;
 
+import java.util.ArrayList;
+import java.util.Iterator;
+import java.util.List;
+
 public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
 {
 
     private final Minecraft mc = Minecraft.getMinecraft();
     private final @NotNull StringBuilder builder = new StringBuilder();
     private final String[] signColorTextures = new String[16];
+    private final BufferedTextMeshRenderer textMeshRenderer = new BufferedTextMeshRenderer();
 
     public TileEntityRendererSign() {
         super();
@@ -91,11 +101,11 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
 //            colorSign = 0xa57319;
             colorSign = 0x695e43;
         }
+        GL11.glDisable(GL11.GL_BLEND);
         model.render(t);
+        GL11.glEnable(GL11.GL_BLEND);
         GL11.glPopMatrix();
 
-
-
         // Render overlay
         GL11.glPushMatrix();
         GL11.glEnable(GL11.GL_BLEND);
@@ -103,7 +113,7 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         GL11.glNormal3f(0, 0, 1);
         GL11.glDepthMask(false);
         final EnumSignPicture picture = tileEntity.getPicture();
-        drawTexturedModalRect(1, 0.5, colorSign,TextureRegistry.getTexture(picture.getTextureKey()));
+        if (picture != EnumSignPicture.NONE) drawTexturedModalRect(1, 0.5, colorSign,TextureRegistry.getTexture(picture.getTextureKey()));
         GL11.glPopMatrix();
 
         // Render text
@@ -113,7 +123,6 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         if (tileEntity.isGlowing()) {
             lightLevel = 1f;
             lightOffset = 96f;
-            GL11.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
             if(LightmapHelper.isLightmapEnabled()) {
                 LightmapHelper.setLightmapCoord(LightmapHelper.getLightmapCoord(15, 15));
             }
@@ -121,38 +130,44 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
 
         GL11.glPushMatrix();
         final float scale2 = 0.2666667f * scale;
-         GL11.glTranslatef(0.0F, height * scale, 1.1f * scale);
-         GL11.glScalef(scale2, -scale2, scale2);
-         GL11.glDepthMask(false);
-         int color = Colors.allSignColors[tileEntity.getColor().id].getARGB();
+        GL11.glTranslatef(0.0F, height * scale, 1.1f * scale);
+        GL11.glScalef(scale2, -scale2, scale2);
+        GL11.glDepthMask(false);
+        int color = Colors.allSignColors[tileEntity.getColor().id].getARGB();
         final int r = (int) MathHelper.clamp((Color.redFromInt(color) * lightLevel + lightOffset), 0, 255);
         final int g = (int)MathHelper.clamp((Color.greenFromInt(color) * lightLevel + lightOffset), 0, 255);
         final int b = (int)MathHelper.clamp((Color.blueFromInt(color) * lightLevel + lightOffset), 0, 255);
-        final int borderR = (int) MathHelper.clamp((Color.redFromInt(color) * lightLevel - 127), 0, 255);
-        final int borderG = (int) MathHelper.clamp((Color.greenFromInt(color) * lightLevel - 127), 0, 255);
-        final int borderB = (int) MathHelper.clamp((Color.blueFromInt(color) * lightLevel - 127), 0, 255);
         color = Color.intToIntARGB(0, r, g, b);
-        int borderColor = Color.intToIntARGB(0, borderR, borderG, borderB);
-        for(int line = 0; line < tileEntity.signText.length; line++)
-        {
-            this.builder.setLength(0);
-            if(line == tileEntity.lineBeingEdited)
-            {
-                this.builder.append("§+§f> §-").append(tileEntity.signText[line]).append("§+§f <§-");
-            } else {
-                this.builder.append(tileEntity.signText[line]);
-            }
-            int _x = -sr.stringWidth(this.builder) / 2;
-            int _y = line * 10 - tileEntity.signText.length * 5;
-            if (tileEntity.isGlowing()) {
-                int _x2 = -sr.stringWidth(tileEntity.signText[line]) / 2;
-                for (float i = -1; i <= 1; i += 1/3f) {
-                    for (float j = -1; j <= 1; j += 1/3f) {
-                        sr.renderDouble(t, tileEntity.signText[line], _x2 + i, _y + j).setColor(borderColor).call();
-                    }
-                }
-            }
-            sr.render(t, this.builder, _x, _y).setColor(color).call();
+
+        CharSequence line1 = tileEntity.signText[0];
+        CharSequence line2 = tileEntity.signText[1];
+        CharSequence line3 = tileEntity.signText[2];
+        CharSequence line4 = tileEntity.signText[3];
+
+        switch (tileEntity.lineBeingEdited) {
+            case 0:
+                this.builder.setLength(0);
+                line1 = this.builder.append("§+§f> §-").append(line1).append("§+§f <§-");
+                break;
+            case 1:
+                this.builder.setLength(0);
+                line2 = this.builder.append("§+§f> §-").append(line2).append("§+§f <§-");
+                break;
+            case 2:
+                this.builder.setLength(0);
+                line3 = this.builder.append("§+§f> §-").append(line3).append("§+§f <§-");
+                break;
+            case 3:
+                this.builder.setLength(0);
+                line4 = this.builder.append("§+§f> §-").append(line4).append("§+§f <§-");
+                break;
+        }
+        final int _x = 0;
+        final int _y = - tileEntity.signText.length * 5;
+        if (tileEntity.isGlowing() && mc.gameSettings.fancyGraphics.value >= 1) {
+            this.textMeshRenderer.render(sr, t, line1, line2, line3, line4, _x, _y, SF.setOutlined(SF.setColor(0, color)));
+        } else {
+            this.textMeshRenderer.render(sr,t, line1, line2, line3, line4, _x, _y, SF.setColor(0, color));
         }
         GL11.glPopMatrix();
 
@@ -175,4 +190,151 @@ public class TileEntityRendererSign extends TileEntityRenderer<TileEntitySign>
         tessellator.draw();
     }
 
+    @Override
+    public void tick() {
+        this.textMeshRenderer.tick();
+    }
+
+    @Override
+    public void onWorldChanged(final World world) {
+        this.textMeshRenderer.flushCaches();
+    }
+
+    @Override
+    public boolean isVisible(@NotNull final TileEntitySign tileEntity, final @NotNull ICamera camera, final float partialTick) {
+        return camera.getFrustum().isVisible(AABB.getTemporaryBB(tileEntity.x, tileEntity.y, tileEntity.z, tileEntity.x + 1, tileEntity.y + 1, tileEntity.z + 1), partialTick);
+    }
+
+    public static class BufferedTextMeshRenderer {
+        private static final long MAX_NON_RENDERED_TIME = 120 * 1000;
+        private final @NotNull List<@NotNull Integer> freeDisplayLists = new ArrayList<>();
+        private final @NotNull List<@NotNull MeshEntry> bufferedMeshes = new ArrayList<>();
+
+        private final @NotNull MeshEntry referenceEntry = new MeshEntry("", "", "", "", 0);
+
+        public void tick() {
+            final Iterator<MeshEntry> iterator = this.bufferedMeshes.iterator();
+            while (iterator.hasNext()) {
+                final MeshEntry entry = iterator.next();
+                if (System.currentTimeMillis() - entry.lastUse > MAX_NON_RENDERED_TIME) {
+                    assert entry.list != -1;
+                    this.freeDisplayLists.add(entry.list);
+                    iterator.remove();
+                }
+            }
+        }
+
+        public void flushCaches() {
+            for (MeshEntry entry : bufferedMeshes) {
+                GLAllocation.deleteDisplayList(entry.list);
+            }
+            bufferedMeshes.clear();
+            for (Integer list : freeDisplayLists) {
+                GLAllocation.deleteDisplayList(list);
+            }
+            freeDisplayLists.clear();
+        }
+
+        public void render(@NotNull final FontRenderer sr,
+                           @NotNull final Tessellator t,
+                           @NotNull final CharSequence line1,
+                           @NotNull final CharSequence line2,
+                           @NotNull final CharSequence line3,
+                           @NotNull final CharSequence line4,
+                           final int x, final int y, final long config) {
+            GL11.glPushMatrix();
+            GL11.glTranslatef(x, y, 0);
+            renderInternal(sr, t, line1, line2, line3, line4, config);
+            GL11.glPopMatrix();
+        }
+
+        private void renderInternal(@NotNull final FontRenderer sr,
+                                    @NotNull final Tessellator t,
+                                    @NotNull final CharSequence line1,
+                                    @NotNull final CharSequence line2,
+                                    @NotNull final CharSequence line3,
+                                    @NotNull final CharSequence line4,
+                                    final long config) {
+            this.referenceEntry.line1 = line1.toString();
+            this.referenceEntry.line2 = line2.toString();
+            this.referenceEntry.line3 = line3.toString();
+            this.referenceEntry.line4 = line4.toString();
+            this.referenceEntry.config = config;
+
+            MeshEntry entry = null;
+            final int size = this.bufferedMeshes.size();
+            for (int i = 0; i < size; i++) {
+                final MeshEntry e = this.bufferedMeshes.get(i);
+                if (this.referenceEntry.equals(e)) {
+                    entry = e;
+                    break;
+                }
+            }
+
+            if (entry != null) {
+                entry.lastUse = System.currentTimeMillis();
+                GL11.glCallList(entry.list);
+            } else {
+                entry = new MeshEntry(line1, line2, line3, line4, config);
+                entry.lastUse = System.currentTimeMillis();
+                entry.list = getDisplayList();
+
+                GL11.glNewList(entry.list, GL11.GL_COMPILE);
+                sr.render(t, line1, -sr.stringWidth(line1) / 2, 0).setConfig(config).call();
+                sr.render(t, line2, -sr.stringWidth(line2) / 2, 10).setConfig(config).call();
+                sr.render(t, line3, -sr.stringWidth(line3) / 2, 20).setConfig(config).call();
+                sr.render(t, line4, -sr.stringWidth(line4) / 2, 30).setConfig(config).call();
+                GL11.glEndList();
+                GL11.glCallList(entry.list);
+
+                this.bufferedMeshes.add(entry);
+            }
+
+        }
+
+        private int getDisplayList() {
+            if (this.freeDisplayLists.isEmpty()) {
+                return GLAllocation.generateDisplayLists(1);
+            } else {
+                return this.freeDisplayLists.remove(0);
+            }
+        }
+
+        public static class MeshEntry {
+            public long config;
+            public @NotNull String line1;
+            public @NotNull String line2;
+            public @NotNull String line3;
+            public @NotNull String line4;
+
+            public long lastUse = 0;
+            public int list = -1;
+
+            public MeshEntry(final @NotNull CharSequence line1, final @NotNull CharSequence line2, final @NotNull CharSequence line3, final @NotNull CharSequence line4, final long config) {
+                this.config = config;
+                this.line1 = line1.toString();
+                this.line2 = line2.toString();
+                this.line3 = line3.toString();
+                this.line4 = line4.toString();
+            }
+
+            @Override
+            public boolean equals(final Object o) {
+                if (o == null || getClass() != o.getClass()) return false;
+
+                final MeshEntry entry = (MeshEntry) o;
+                return this.config == entry.config && this.line1.equals(entry.line1) && this.line2.equals(entry.line2) && this.line3.equals(entry.line3) && this.line4.equals(entry.line4);
+            }
+
+            @Override
+            public int hashCode() {
+                int result = Long.hashCode(this.config);
+                result = 31 * result + this.line1.hashCode();
+                result = 31 * result + this.line2.hashCode();
+                result = 31 * result + this.line3.hashCode();
+                result = 31 * result + this.line4.hashCode();
+                return result;
+            }
+        }
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
index bf794ec4c..b95e9e87b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererStatue.java
@@ -123,7 +123,7 @@ public class TileEntityRendererStatue extends TileEntityRenderer<TileEntityStatu
             } else if (item instanceof IArmorItem) {
                 final IArmorItem armorItem = (IArmorItem) item;
                 if (armorItem.getArmorMaterial() == null) return false;
-                bindTexture(String.format("/assets/%s/textures/armor/%s_%d.png", armorItem.getArmorMaterial().identifier.namespace, armorItem.getArmorMaterial().identifier.value, (layer != 2 ? 1 : 2)));
+                bindTexture(String.format("/assets/%s/textures/armor/%s_%d.png", armorItem.getArmorMaterial().identifier.namespace(), armorItem.getArmorMaterial().identifier.value(), (layer != 2 ? 1 : 2)));
             } else {
                 return false;
             }
diff --git a/game/client/src/main/java/net/minecraft/client/sound/SoundRepository.java b/game/client/src/main/java/net/minecraft/client/sound/SoundRepository.java
index ead8db828..37fd7f76e 100644
--- a/game/client/src/main/java/net/minecraft/client/sound/SoundRepository.java
+++ b/game/client/src/main/java/net/minecraft/client/sound/SoundRepository.java
@@ -1,14 +1,17 @@
 package net.minecraft.client.sound;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.data.registry.Registry;
 import net.minecraft.core.util.collection.NamespaceID;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.slf4j.Logger;
 
 import java.util.*;
 
 public class SoundRepository extends Registry<NamedSoundRepository> {
+    private static final Logger LOGGER = LogUtils.getLogger();
     protected static Minecraft mc = null;
     public static SoundRepository SOUNDS = null;
     public static Set<String> namespaces = new HashSet<>();
@@ -32,15 +35,15 @@ public class SoundRepository extends Registry<NamedSoundRepository> {
 
     public @Nullable SoundEvent getSoundEvent(@Nullable NamespaceID namespaceID) {
         if (namespaceID == null) return null;
-        NamedSoundRepository soundRepository = getItem(namespaceID.namespace);
+        NamedSoundRepository soundRepository = getItem(namespaceID.namespace());
         if (soundRepository == null) {
-            if (!cachedRepositoryErrors.contains(namespaceID.namespace)) {
-                System.err.println("Could not find sound repository under namespace '" + namespaceID.namespace + "'!");
-                cachedRepositoryErrors.add(namespaceID.namespace);
+            if (!cachedRepositoryErrors.contains(namespaceID.namespace())) {
+                LOGGER.error("Could not find sound repository under namespace '{}'!", namespaceID.namespace());
+                cachedRepositoryErrors.add(namespaceID.namespace());
             }
             return null;
         }
-        return soundRepository.getItem(namespaceID.value);
+        return soundRepository.getItem(namespaceID.value());
     }
 
     public @Nullable SoundEntry getSoundEntry(@Nullable String key) {
@@ -53,8 +56,8 @@ public class SoundRepository extends Registry<NamedSoundRepository> {
         SoundEvent event = getSoundEvent(namespaceID);
         if (event == null) {
             if (!cachedEntryErrors.contains(namespaceID)) {
-                System.err.println("Could not find sound event in namespace '" + namespaceID.namespace + "' matching key '" + namespaceID.value + "'!");
-                cachedEntryErrors.add(namespaceID);
+                LOGGER.error("Could not find sound event in namespace '{}' matching key '{}'!", namespaceID.namespace(), namespaceID.value());
+                cachedEntryErrors.add(namespaceID.makePermanent());
             }
             return null;
         }
@@ -101,7 +104,7 @@ public class SoundRepository extends Registry<NamedSoundRepository> {
             value = split[1];
             if (namespace.isEmpty()) throw new IllegalArgumentException("Invalid key '" + key + "', Namespace must not be empty!");
         }
-        return new NamespaceID(namespace, value);
+        return NamespaceID.getTemp(namespace, value);
     }
 
     public static void initialize(Minecraft mc) {
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
index bf31e01a2..affc2f3fa 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/block/mojang/BlockModelMojangData.java
@@ -112,7 +112,7 @@ public class BlockModelMojangData implements BlockModelData {
         @Nullable final Map<@NotNull Direction, @NotNull Integer> particleIndices,
         @Nullable final List<@NotNull Element> elements)
     {
-        this.modelId = id;
+        this.modelId = id.makePermanent();
         this.parent = parent;
         if (parent != null) {
             final BlockModelMojangData parentData = BlockModelMojangData.Cache.loadModelData(texturePackList, parent);
@@ -253,7 +253,7 @@ public class BlockModelMojangData implements BlockModelData {
                 }
             }
             try {
-                return new BlockModelMojangData(texturePackList, new NamespaceID(id), this.parent, this.ambientOcclusion, this.renderLayer, this.displayPosMap, this.textures, this.particleIndices, elementList);
+                return new BlockModelMojangData(texturePackList, NamespaceID.getPermanent(id), this.parent, this.ambientOcclusion, this.renderLayer, this.displayPosMap, this.textures, this.particleIndices, elementList);
             } catch (final HardIllegalArgumentException e) {
                 throw new IllegalArgumentException(e);
             }
@@ -311,7 +311,7 @@ public class BlockModelMojangData implements BlockModelData {
         public static @Nullable BlockModelMojangData loadModelData(@NotNull final TexturePackList texturePackList, @NotNull final NamespaceID id) {
             final String s = id.toString();
             if (modelDataCache.containsKey(s)) return modelDataCache.get(s);
-            final BlockModelMojangData.Builder data = loadFromStream(texturePackList.getResourceAsStream(String.format(RESOURCE_PATH, id.namespace, id.value)));
+            final BlockModelMojangData.Builder data = loadFromStream(texturePackList.getResourceAsStream(String.format(RESOURCE_PATH, id.namespace(), id.value())));
             if (data == null) {
                 LOGGER.error("Could not locate block model data for id '{}'!", id);
                 return null;
diff --git a/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/EntityGeometryMojangData.java b/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/EntityGeometryMojangData.java
index 69312810e..83a9f9efc 100644
--- a/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/EntityGeometryMojangData.java
+++ b/game/client/src/main/java/org/useless/dragonfly/data/entity/mojang/EntityGeometryMojangData.java
@@ -291,7 +291,7 @@ public class EntityGeometryMojangData implements EntityModelData {
                         for (final Map.Entry<String, JsonElement> entry : renderersObj.entrySet()) {
                             final NamespaceID id;
                             try {
-                                id = new NamespaceID(entry.getKey());
+                                id = NamespaceID.getPermanent(entry.getKey());
                             } catch (final HardIllegalArgumentException exception) {
                                 LOGGER.error("Id '{}' is malformed!", entry.getKey(), exception);
                                 continue;
diff --git a/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java b/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java
index c8246ab29..26c36de60 100644
--- a/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java
+++ b/game/core/src/main/java/net/minecraft/core/achievement/Achievement.java
@@ -25,7 +25,7 @@ public class Achievement extends Stat
 
     public Achievement(NamespaceID id, String name, int iconItemId, Achievement parent)
     {
-        super(new NamespaceID(id.namespace, "achievement/" + id.value), "achievement." + name);
+        super(NamespaceID.getPermanent(id.namespace(), "achievement/" + id.value()), "achievement." + name);
         this.iconItemId = iconItemId;
         this.description = "achievement." + name;
 
